/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2000 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * Portions of this software are based upon public domain software
 * originally written at the National Center for Supercomputing Applications,
 * University of Illinois, Urbana-Champaign.
 */
package com.bonevich.eclipse.cvsgrapher.editors;

import com.bonevich.eclipse.cvsgrapher.model.CvsGraphVersionModel;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.text.*;

import java.util.Iterator;

/**
 * The controller edit part for CVS branch nodes.
 * 
 * @author jbonevic
 */
public final class CvsGraphVersionEditPart
	extends AbstractCvsGraphNodeEditPart 
{

	/**
	 * @see org.eclipse.gef.editparts.AbstractCvsGraphNodeEditPart#createFigure()
	 */
	protected IFigure createFigure()
	{
		CvsGraphVersionModel version = (CvsGraphVersionModel) getNodeModel();
		setViewHelper(new CvsGraphNodeViewHelper());

		RoundedRectangle info = new RoundedRectangle();
		info.setCornerDimensions(new Dimension(16,16));
		info.setLayoutManager(new StackLayout());
		info.setBackgroundColor(ColorConstants.lightGray);
		info.setOpaque(true);
		
		FlowPage page = new FlowPage();
		page.setBorder(new MarginBorder(3,3,3,3));
		page.setHorizontalAligment(PositionConstants.CENTER);
		page.setBackgroundColor(ColorConstants.lightGray);
		
		Label tooltip = new Label(getPopupText(version));
		page.setToolTip(tooltip);

		BlockFlow versionBlock = new BlockFlow();
		TextFlow versionLabel = new TextFlow(version.getVersion());
		versionLabel.setFont(VERSION);
		versionBlock.add(versionLabel);
		
		BlockFlow timestampBlock = new BlockFlow();
		TextFlow timestampLabel = new TextFlow(version.getTimestamp());
		timestampLabel.setLayoutManager(new SimpleTextLayout(timestampLabel));
		timestampLabel.setFont(INFO);
		timestampLabel.setForegroundColor(ColorConstants.darkGreen);
		timestampBlock.add(timestampLabel);

		BlockFlow authorBlock = new BlockFlow();
		TextFlow authorLabel = new TextFlow(version.getAuthor());
		authorLabel.setFont(INFO);
		authorLabel.setForegroundColor(ColorConstants.darkGray);
		authorBlock.add(authorLabel);
		
		page.add(versionBlock);
		page.add(authorBlock);
		page.add(timestampBlock);
		
		Iterator itr = version.getTags().iterator();
		while (itr.hasNext())
		{
			BlockFlow tagBlock = new BlockFlow();
			TextFlow tagLabel = new TextFlow((String) itr.next());
			tagLabel.setFont(INFO);
			tagLabel.setForegroundColor(ColorConstants.darkBlue);
			tagBlock.add(tagLabel);
			page.add(tagBlock);
		}
		
		info.add(page);
		info.setLocation(CvsGraphNodeViewHelper.INITIAL_LOCATION);
		
		setAnchor(new ChopboxAnchor(info));
		
		return info;
	}

	private String getPopupText(CvsGraphVersionModel version)
	{
		StringBuffer buf = new StringBuffer();
		buf.append("Version: ");
		buf.append(version.getVersion());
		buf.append("\nCommit Remark: ");
		buf.append(version.getComment());
		buf.append("\nAuthor: ");
		buf.append(version.getAuthor());
		buf.append("\nDate: ");
		buf.append(version.getTimestamp());
		return buf.toString();
	}
	
}
